#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void stampa_niza(int* a, int n) {
    int i;
    for (i = 0; i < n; i++) {
        printf("%d ", a[i]);
    }
    printf("\n");
}

void stampa_matrice_st(int mat[][100], int m, int n) {
    int i, j;
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            printf("%d ", mat[i][j]);
        }
        printf("\n");
    }
}

void stampa_matrice_din(int** mat, int m, int n) {
    int i, j;
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            printf("%d ", mat[i][j]);
        }
        printf("\n");
    }
}

void init_rnd(int A[][100], int m, int n) {
    srand(time(0));
    int i, j;
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            A[i][j] = rand() % 10;
        }
    }
}

void transponovanje1(int A[][100], int B[][100], int m, int n) {
    int i, j;
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            B[j][i] = A[i][j];
        }
    }
}

int main()
{
    // staticka alokacija

    int a[] = {8, 25, 2, 37, 14, 5, 40};
    stampa_niza(a, 7);

    int b[5] = {1, 2, 3};
    stampa_niza(b, 5);

    int c[5] = {0};
    stampa_niza(c, 5);

    // int n = 10;
    // int d[n];

    int n = 10;
    int* d = malloc(n*sizeof(int));
    d[0] = 1;
    d[1] = 2;
    d[2] = 3;
    stampa_niza(d, n);
    free(d);

    int e[10];
    stampa_niza(e, 10);

    int A[3][3];
    A[0][0] = 1;
    printf("%d\n", A[0][0]);

    /// Nije dozvoljeno B[][] i B[3][]

    int B[][3] = {{1, 2, 3}, {4, 5, 6}, {7, 8, 9}};
    printf("%d\n", B[0][0]);
    printf("%d\n", B[0][2]);
    printf("%d\n", B[1][1]);
    printf("%d\n", B[2][1]);

    int m = 3;
    n = 3;
    // {0}
    // {{1}, {4, 5}, {7, 8, 9}}
    int C[100][100] = {{1, 2, 3}, {4, 5, 6}, {7, 8, 9}};
    stampa_matrice_st(C, m, n);

    int** D = malloc(m*sizeof(int*));
    int i;
    for (i = 0; i < m; i++) {
        D[i] = malloc(n*sizeof(int));
    }
    D[0][0] = 5;
    D[0][1] = 10;
    D[0][2] = 15;
    printf("%d %d %d\n", D[0][0], D[0][1], D[0][2]);

    stampa_matrice_din(D, m, n);

    for (i = 0; i < m; i++) {
        free(D[i]);
    }
    free(D);

    int E[100][100], F[100][100];
    init_rnd(E, 3, 5);
    transponovanje1(E, F, 3, 5);
    printf("\n");
    stampa_matrice_st(E, 3, 5);
    printf("\n");
    stampa_matrice_st(F, 5, 3);
    printf("\n");

    return 0;
}
